<?php

function genie_refresher_recalcul_dist($t) {
	include_spip("inc/refresher_functions");
	$t = time();
	$n = 0;
	$pull_list = array();
	$res = sql_select("id, uri, type","refresher_queue","date<=NOW()","","priorite,date,id",_RECALCUL_PROCESS_NB);
	spip_log("recalcul start", "refresher_recalcul"._LOG_INFO_IMPORTANTE);
	while($row = sql_fetch($res)){
		// all the pull jobs will come first
		if($row['type'] == 'pull'){
			$pull_list[] = $row['uri'];
		}
		else{
			// if we are in push jobs and the pull list is not empty, we process it
			if(sizeof($pull_list) > 0){
				traiter_pull($pull_list);
				$pull_list = array();
			}
			$n++;
			// if server load high, we leave
			$instant_load = 1;
			if(function_exists('sys_getloadavg')){ 
				$load = sys_getloadavg();
				$instant_load = $load[0];
			}
			if(defined('_REFRESHER_MAX_LOAD') && $instant_load > _REFRESHER_MAX_LOAD){ 
				spip_log("warmup interrupted (n=".$n."): Server load too high", "refresher_recalcul"._LOG_INFO_IMPORTANTE);
				return 1;
			}
			// if we already took 160 seconds, we leave
			if(defined('_REFRESHER_MAX_TIME') && time() - $t > _REFRESHER_MAX_TIME){ 
				spip_log("warmup interrupted (n=".$n."): timeout("._REFRESHER_MAX_TIME." seconds)", "refresher_recalcul"._LOG_INFO_IMPORTANTE);
				return 1;
			}
			// if mysql unresponsive, we leave
			if(!spip_connect()){ 
				spip_log("warmup interrupted (n=".$n."): MYSQL unresponsive", "refresher_recalcul"._LOG_INFO_IMPORTANTE);
				return 1;
			}
			// if too many mysql processes, we leave
			$res_proc = spip_query('show processlist');
			if(defined('_REFRESHER_MAX_SQL_PROCESSES') && sql_count($res_proc) > _REFRESHER_MAX_SQL_PROCESSES){ 
				spip_log("warmup interrupted (n=".$n."): Too many MYSQL processes (".sql_count($res_proc).")", "refresher_recalcul"._LOG_INFO_IMPORTANTE);
				return 1;
			}
			// if everything ok so far, we send http requests
			spip_log("warmup processing URI (n=".$n."): ".$GLOBALS['meta']['adresse_site'].'/'.$row['uri'], "refresher_recalcul"._LOG_INFO_IMPORTANTE);
			$parallel_uris = array($row['uri']);
			$parallel_urls = array($GLOBALS['meta']['adresse_site'].'/'.$row['uri']);
			$parallel_ids = array($row['id']);
			for($i = 1; $i < _RECALCUL_PARALLEL_NB; $i ++){
				if($row = sql_fetch($res)){
					//spip_log("warmup processing URI (n=".$n."): ".$GLOBALS['meta']['adresse_site'].'/'.$row['uri'], "refresher_recalcul"._LOG_INFO_IMPORTANTE);
					$parallel_uris[] = $row['uri'];
					$parallel_urls[] = $GLOBALS['meta']['adresse_site'].'/'.$row['uri'];
					$parallel_ids[] = $row['id'];
				}
			}
			refresh_url($parallel_urls, array(), "refresher_recalcul");
			sql_delete("refresher_queue", "id IN (".implode(',', $parallel_ids).")");
		}
	}
	if(sizeof($pull_list) > 0) traiter_pull($pull_list);
	spip_log("recalcul end", "refresher_recalcul"._LOG_INFO_IMPORTANTE);
	return 1;
}

?>